#ifndef _PRVCLASS_TINPUT_H
#define _PRVCLASS_TINPUT_H

struct tinput {
	char *showed;	/* ptr to text[] (if user just looks into history) */
	/* or to edited (if user started to edit some bufer) */

	char **text;	/* history (and also safecopy of edited entry) */
	char *edited;	/* edit-buffer */

	/* maximum lenght of buffer */
	unsigned int maxlen;
	/* maximum number of buffers plus one for text[0] */
	unsigned int maxhistory;

	/* number of buffers in history */
	unsigned int numhist;

	/* which buffer from history is showed */
	unsigned int buf_show;
	/* which buffer from history is edited now */
	unsigned int buf_edit;


	int inputmode;
	/* cursor position */
	unsigned int curspos;

	/* inputline will accept only chars from this string */
	char *acceptchars;
	/* inputline will reject chars from this string */
	char *rejectchars;
};

void tinput_cleanup(struct tobj *obj);
int tinput_setup(struct tobj *obj, struct tobj_fnc *fnc,
		char *deftext, unsigned int maxlen);

#endif
