#ifndef _TDISPLAY_H
#define _TDISPLAY_H

#define TSCR_NOCURSOR		(0)
#define TSCR_SOLIDCURSOR	(1)
#define TSCR_LINECURSOR		(2)

#define  BLACK     (0)		/* dark colors */
#define  BLUE      (1)
#define  GREEN     (2)
#define  CYAN      (3)
#define  RED       (4)
#define  MAGENTA   (5)
#define  BROWN     (6)
#define  LIGHTGRAY (7)
#define  DARKGRAY  (8)		/* light colors */
#define  LIGHTBLUE (9)
#define  LIGHTGREEN (10)
#define  LIGHTCYAN  (11)
#define  LIGHTRED   (12)
#define  LIGHTMAGENTA (13)
#define  YELLOW       (14)
#define  WHITE        (15)

#define BLINK       128		/* blink bit */


int t_init(void);
unsigned int t_screencols(void);
unsigned int t_screenrows(void);
void t_resize(void);
void t_free(void);

void t_putchar(unsigned char c);
void t_lcputs(char *s, int key, unsigned char c, unsigned char c2);
void t_cputs(char *string);
void t_clrscr(void);
void t_clreol(void);
char t_gethatch(int type);
void t_drawframe(unsigned int width, unsigned int height, int type);

void t_textcolor(unsigned char col);
void t_textbackground(unsigned char col);
void t_textattr(unsigned char attrs);

void t_gotoxy(unsigned int x, unsigned int y);
unsigned int t_wherex(void);
unsigned int t_wherey(void);

void t_force_refresh(void);
void t_sync(void);
void t_sync_small(void);

void t_cursormove(unsigned int x, unsigned int y);
void t_cursortype(int type);

void t_cleanbuffer();
#ifndef _DIS_H
unsigned int t_screen_width, t_screen_height, t_screen_size_changed;
#undef _DIS_H
#endif

#endif
