#include "tsys.h"
#include "tobj.h"
#include "twin.h"
/* defines of events and methods */
#include "tlist.h"
#include "tinput.h"
#include "tscroll.h"
#include "miscfunc.h"
#include <string.h>
#include <ctype.h>


#include "prvclass/tlist.h"


void tlist_dorefresh(struct tobj *obj)
{
	unsigned int bx, by;
	struct tlist *list;
	unsigned int i, j;
	int endchar = 0, endline = 0;
	int objactive = 0;
	char c = 0;

	list = (struct tlist *) obj->data;

	bx = t_wherex();
	by = t_wherey();

	if (tobj_isactive(obj))
		objactive = 1;


	for (i = 0; i < obj->h; i++) {

		/* are we run out of lines? */
		if (!endline)
			if (list->lines[i+list->firstline] == NULL)
				endline = 1;

		/* setting colour */
		if ((i + list->firstline) == list->active) {
			if (objactive) {
				t_textcolor(obj->fgcolor);
				t_textbackground(obj->bgcolor2);
			} else {
				t_textcolor(obj->fgcolor2);
				t_textbackground(obj->bgcolor);
//				t_textcolor(obj->fgcolor);
//				t_textbackground(obj->bgcolor);
			}
		} else {
			t_textcolor(obj->fgcolor2);
			t_textbackground(obj->bgcolor);
		}

		/* checking if ( strlen < firstchar ) */
		if (!endline)
			for (j = 0; j < list->firstchar; j++) {
				c = list->lines[i + list->firstline][j];
				if (c == '\n' || c == '\0' || c == '\r') {
					endchar = 1;
					break;
				}
			}

		/* drawing list box */
		t_gotoxy(bx, by + i);
		for (j = 0; j < obj->w; j++) {
			if (!endline && !endchar) {
				c = list->lines[i + list->firstline]
				    [j + list->firstchar];

				if (c == '\n' || c == '\0' || c == '\r')
					endchar = 1;
			}

			if (endline || endchar) {
				if ((i + list->firstline) == list->active
						&& j == obj->w-1)
					t_putchar('<');
				else
					t_putchar(' ');
			} else
				t_putchar(c);
		}
		endchar = 0;

	}

}
void tlist_dorefresh2(struct tobj *obj)
{
	unsigned int bx, by;
	struct tlist *list;
	unsigned int i, j;
	int endchar = 0, endline = 0;
	int objactive = 0;
	char c = 0;

	list = (struct tlist *) obj->data;

	bx = t_wherex();
	by = t_wherey();

	if (tobj_isactive(obj))
		objactive = 1;


	for (i = 0; i < obj->h; i++) {

		/* are we run out of lines? */
		if (!endline)
			if (list->lines[i+list->firstline] == NULL)
				endline = 1;

		/* setting colour */
		if ((i + list->firstline) == list->active) {
			if (objactive) {
				t_textcolor(obj->fgcolor);
				t_textbackground(obj->bgcolor2);
			} else {
				t_textcolor(obj->fgcolor);
				t_textbackground(obj->bgcolor);
			}
		} else {
			t_textcolor(obj->fgcolor2);
			t_textbackground(obj->bgcolor);
		}

		/* checking if ( strlen < firstchar ) */
		if (!endline)
			for (j = 0; j < list->firstchar; j++) {
				c = list->lines[i + list->firstline][j];
				if (c == '\n' || c == '\0' || c == '\r') {
					endchar = 1;
					break;
				}
			}

		/* drawing list box */
		t_gotoxy(bx, by + i);
		for (j = 0; j < obj->w; j++) {
			if (!endline && !endchar) {
				c = list->lines[i + list->firstline]
				    [j + list->firstchar];

				if (c == '\n' || c == '\0' || c == '\r')
					endchar = 1;
			}


			if (endline || endchar)
				t_putchar(' ');
			else
				t_putchar(c);
		}
		endchar = 0;

	}

}

/* activates n line of list ( doesn't check if 0 <= n < list->nlines ) */
static void tlist_activate(struct tobj *obj, unsigned long n)
{
	struct tlist *list;
	list = (struct tlist *) obj->data;

	if (n < list->nlines) {
		tevent_send(obj, EVENT_TYPE_USER, EVENT_TLIST_CHANGE);
		list->active = n;

		/* correcting first line */
		if (n < list->firstline)
			list->firstline = n;
		else if (n >= (list->firstline + obj->h))
			list->firstline = UNSIGNSUB(n + 1, obj->h);

		tobj_dorefresh(obj);
	}
}

static void tlist_entry_del(struct tobj *obj, unsigned long line)
{
	struct tlist *list;
	list = obj->data;

	if (line < list->nlines) {
		unsigned long i;
		
		if ( strlen( list->lines[line] ) == list->nchars ){
			unsigned long len;
			list->nchars = 0;
			for( i = 0 ; i < list->nlines ; i++ ){
				if ( i != line ){
					len = strlen( list->lines[i] );
					if ( len > list->nchars )
						list->nchars = len;
				}
			}
			if (list->firstchar > UNSIGNSUB(list->nchars,obj->w))
				list->firstchar=UNSIGNSUB(list->nchars,obj->w);
		}
		if( list->lines[line] )
			free( list->lines[line] );

		for( i = line ; i+1 < list->nlines ; i++ )
			list->lines[i] = list->lines[i + 1];
		
		list->nlines--;
		list->lines[list->nlines] = NULL;
		
		if (list->active >= list->nlines )
			tlist_activate( obj , list->nlines - 1);

		tobj_dorefresh(obj);
	}
}


static int tlist_entry_delall(struct tobj *obj)
{
	struct tlist *list;
	list = obj->data;

	free( list->lines );
	if ((list->lines = malloc( (1) * sizeof(char *)))) {
		list->lines[0] = NULL;
		list->nlines = 0;
		list->nchars = 0;
		list->firstline = 0;
		list->firstchar = 0;

		tobj_dorefresh(obj);
		return 1;
	} else
		return 0;

}
static int tlist_entry_add(struct tobj *obj, char *entry)
{
	struct tlist *list;
	char **tmp;
	unsigned int len;

	list = obj->data;

	if ((tmp =
	     realloc(list->lines, (list->nlines + 1 + 1) * sizeof(char *)))) {
		list->lines = tmp;
		list->nlines++;
		if (!(list->lines[list->nlines - 1] = strdup(entry)))
			return 0;
		list->lines[list->nlines]=NULL;

		len = strlen(entry);
		if (len > list->nchars)
			list->nchars = len;

		tobj_dorefresh(obj);
		return 1;
	} else
		return 0;
}

static void tlist_set_title(struct tobj *obj, char *title)
{
	unsigned int len;
	struct tlist *list = (struct tlist*)obj->data;
	
	len = list->active;
	free(list->lines[len]);
	list->lines[len] = strdup(title);
	len = strlen(title);
	if (len > list->nchars)
		list->nchars = len;
		
	tobj_dorefresh(obj);
}

static int tlist_set(struct tobj *obj, struct tobj_set *tos)
{
	struct tlist *list;
	list = obj->data;

	switch (tos->attr) {
	case TLIST_ACTIVE:
		tlist_activate(obj, (long) tos->data);
		break;
	case TLIST_ACTIVE_TITLE:
		tlist_set_title(obj, (char *)tos->data);
		break;
	default:
		return 0;
	}

	return 1;
}

static int tlist_get(struct tobj *obj, struct tobj_get *tog)
{
	struct tlist *list;
	list = obj->data;

	switch (tog->attr) {
	case TLIST_FIRST_LINE:
		*(tog->data) = list->firstline;
		break;
	case TLIST_FIRST_CHAR:
		*(tog->data) = list->firstchar;
		break;
	case TLIST_ACTIVE:
		*(tog->data) = list->active;
		break;
	case TLIST_ACTIVE_STRING:
		*(tog->data) = TPDATA(list->lines[list->active]);
		break;
	case TLIST_LIST:
		*(tog->data) = TPDATA(list->lines);
		break;
	case TLIST_LIST_LEN:
		*(tog->data) = list->nlines;
		break;
	default:
		return 0;
	}

	return 1;
}
int tlist_domethod(struct tobj *obj, long method, long data)
{
	struct tlist *list;
	list = (struct tlist *) obj->data;

	switch (method) {
	case TOBJ_SET:
		return tlist_set(obj, (struct tobj_set *) data);
	case TOBJ_GET:
		return tlist_get(obj, (struct tobj_get *) data);
	case TLIST_SCROLL_LEFT:
		if (list->firstchar > 0) {
			list->firstchar -= 1;
			tobj_dorefresh(obj);
		}
		break;
	case TLIST_SCROLL_RIGHT:
		if (list->firstchar < UNSIGNSUB(list->nchars,obj->w)) {
			list->firstchar += 1;
			tobj_dorefresh(obj);
		}
		break;
	case TLIST_ACTIVATE_FIRST:
		tlist_activate(obj, 0);
		break;
	case TLIST_ACTIVATE_LAST:
		tlist_activate(obj, list->nlines - 1);
		break;
	case TLIST_ACTIVATE_NEXT:
		tlist_activate(obj, list->active + 1);
		break;
	case TLIST_ACTIVATE_PREV:
		tlist_activate(obj, list->active - 1);
		break;
	case TLIST_ACTIVATE:
		tlist_activate(obj, (long) data);
		break;
	case TLIST_ENTRY_DEL:
		tlist_entry_del(obj, (long)data );
		break;
	case TLIST_ENTRY_DELALL:
		tlist_entry_delall(obj );
		break;
	case TLIST_ENTRY_ADD:
		if (!(tlist_entry_add(obj, (char *) data)))
			tsys_error_exit
			    ("ERROR: While adding new entry to the list\n");
		break;
//	case TLIST_MOVE_UP:
		
	default:
		return 0;
	}
	return 1;
}

static void tlist_accept(struct tobj *obj)
{
	/* Change active object to next one */
	tobj_domethod(obj->parent, TWIN_ACTIVATE_NEXT, 0);

	tevent_send(obj, EVENT_TYPE_USER, EVENT_TLIST_ACCEPT);
}

static void tlist_reject(struct tobj *obj)
{
	/* Change active object to next one */
	tobj_domethod(obj->parent, TWIN_ACTIVATE_NEXT, 0);

	tevent_send(obj, EVENT_TYPE_USER, EVENT_TLIST_REJECT);
}

int tlist_doevent(struct tobj *obj, int keycode)
{
	struct tlist *list;
	list = (struct tlist *) obj->data;

	switch (keycode) {
	case '<':
		tobj_domethod(obj, TLIST_SCROLL_LEFT, 0);
		break;
	case '>':
		tobj_domethod(obj, TLIST_SCROLL_RIGHT, 0);
		break;
	case K_UP:
		tobj_domethod(obj, TLIST_ACTIVATE_PREV, 0);
		break;
	case K_DOWN:
		tobj_domethod(obj, TLIST_ACTIVATE_NEXT, 0);
		break;
	case K_HOME:
		tobj_domethod(obj, TLIST_ACTIVATE_FIRST, 0);
		break;
	case K_END:
		tobj_domethod(obj, TLIST_ACTIVATE_LAST, 0);
		break;
	case K_PGUP:
		tobj_domethod(obj, TLIST_ACTIVATE,
			       (UNSIGNSUB(list->active, obj->h)));
		break;
	case K_PGDN:
		tobj_domethod(obj, TLIST_ACTIVATE,
			       (MIN(list->active + obj->h, list->nlines - 1)));
		break;
	case K_RET:
		tlist_accept(obj);
		break;
	case K_ESC:
		tlist_reject(obj);
		break;
/*	case K_CTL_A:
		tobj_domethod(obj, TLIST_MOVE_UP, 0);
	case K_CTL_S:
		tobj_domethod(obj, TLIST_MOVE_DOWN, 0);*/
	default:
		/* keycode not used. maybe someone will use it */
		return 0;
	}
	return 1;
}

void tlist_cleanup(struct tobj *obj)
{
	struct tlist *list;
	unsigned long i;
	list = (struct tlist *) obj->data;

	if (list->lines) {
		for (i = 0; i < list->nlines; i++) {
			if (list->lines[i]) {
				free(list->lines[i]);
				list->lines[i] = NULL;
			}
		}
		
		free(list->lines);
		list->lines = NULL;
	}
}
void tlist_free(struct tobj *obj)
{
	struct tlist *list;
	list = (struct tlist *) obj->data;

	tlist_cleanup( obj );

	if (list)
		free(list);

}

int tlist_setup(struct tobj *obj,  struct tobj_fnc *fnc,
			char **texttab)
{
	struct tlist *list;
	char nomem[] = "ERROR: While allocating memory for tlist.\n";
	list = (struct tlist *) obj->data;

	if (texttab){
		for (list->nlines = 0; texttab[list->nlines] != NULL;
				list->nlines++);

		if (!(list->lines = calloc(list->nlines + 1, sizeof(char *)))) {
			tsys_error(nomem);
			return 0;
		} else {
			unsigned long i;
			for (i = 0; texttab[i] != NULL; i++) {
				unsigned int len;

				if (!(list->lines[i] = strdup(texttab[i]))) {
					tsys_error(nomem);
					return 0;
				}

				len = strlen(list->lines[i]);
				if (len > list->nchars)
					list->nchars = len;
			}
		}
	}
	else {
		if (!(list->lines = calloc( 1, sizeof(char *)))) {
			tsys_error(nomem);
			return 0;
		} 
		list->nlines = 0;
		list->nchars = 0;
		list->lines[0] = NULL;
	}

	list->active = 0L;
	list->firstline = 0L;
	list->firstchar = 0L;


	fnc->free = &tlist_free;
	fnc->dorefresh = &tlist_dorefresh;
	fnc->doevent = &tlist_doevent;
	fnc->domethod = &tlist_domethod;

	return 1;
}
struct tobj *tlist_init(struct tobj *parent, unsigned int x,
			unsigned int y, unsigned int w, unsigned int h,
			char **texttab)
{
	struct tobj *obj;
	struct tlist *list;
	char nomem[] = "ERROR: While allocating memory for tlist.\n";

	if (!(obj = calloc(1, sizeof(struct tobj)))) {
		tsys_error(nomem);
		return 0;
	}
	if (!(list = calloc(1, sizeof(struct tlist)))) {
		tsys_error(nomem);
		return 0;
	} else {
		obj->data = list;

		obj->x = x;
		obj->y = y;
		/* making space for search inputline */
		obj->h = h;
		/* making space for scrollbar */
		obj->w = w;

		/* setting default values */
		obj->fgcolor = TLISTFG;
		obj->fgcolor2 = TLISTFG2;
		obj->bgcolor = TLISTBG;
		obj->bgcolor2 = TLISTBG2;
		obj->activeable = 1;
		obj->parent=parent;

		if (( tlist_setup( obj, &obj->fnc, texttab ) )){
			tobj_init(parent, obj);
			return obj;
		}
		else
			return 0;
	}
}
